##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (CSV)	= PkgName
# sampledir (ksm-csv)	= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (csv)	= config file name (no extension)
# sampledm (csvd)	= the daemon (rc-script, rc-link, systemd.service)
# sample (csv)		= all others
##############################################################################

# Specfile for CSV

%define name		ksm-csv
%define version		0.0.1
%define release		1.0.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	CSV programs
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	csvpkg,csvcapab
Requires:	ksm-lib-sh >= 4.0.0-0.0.0
#Requires:	ksm-csv = %{version}-%{release}	# if lang pkg
#Provides:	csvd
#Conflicts:	csvd-other,libcsv == 0.0.0
#Obsoletes:	mycsvd

%description
This package contains programs for csv handling.
The package contains the following programs:

 csv-cat, csv-clean,  manage-csv

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/csv.conf
#%config %{_confdir}/csv.conf
#%config %{_scnfdir}/csv
#%attr(644,root,root)%{_confdir}/csv.conf
#%attr(644,root,root)%{_scnfdir}/csv

#%attr(744,root,root)%{_rcdir}/csvd
#%attr(777,root,root)%{_sbindir}/rccsvd
#%attr(744,root,root)%{_sbindir}/csvd.sh

%attr(755,root,root)%{_bindir}/csv-cat
%attr(755,root,root)%{_bindir}/csv-clean
%attr(755,root,root)%{_bindir}/manage-csv

%{_datadir}/RELEASE
%{_datadir}/VERSION
#%attr(744,root,root)%{_datadir}/csvd.rc
#%{_datadir}/csvd.service

#/usr/share/applications/csv.desktop

#%{_icondir}/16x16/apps/csv.png
#%{_icondir}/22x22/apps/csv.png
#%{_icondir}/32x32/apps/csv.png
#%{_icondir}/48x48/apps/csv.png
#%{_icondir}/64x64/apps/csv.png
#%{_icondir}/128x128/apps/csv.png
#%{_icondir}/256x256/apps/csv.png
#%{_icondir}/512x512/apps/csv.png
#/usr/share/pixmaps/csv.png

%docdir %{_man1dir}
%{_man1dir}/csv-cat.1.gz
%{_man1dir}/csv-clean.1.gz
%{_man1dir}/manage-csv.1.gz

%docdir %{_man8dir}
#%{_man8dir}/csvd.sh.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
#test -e %{_confdir}/csv.conf && cp %{_confdir}/csv.conf %{_confdir}/csv.conf.rpmsave
#test -e %{_scnfdir}/csv && cp %{_scnfdir}/csv %{_scnfdir}/csv.rpmsave

# disable csv daemon and stop csvd
#test -x %{_bindir}/togglecsv && %{_bindir}/togglecsv -d -q > /dev/null 2>&1
#test -x %{_rcdir}/csvd && %{_rcdir}/csvd stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/csv.directory \
#	/usr/share/applications/csv.desktop \
#	/usr/share/applications/csv-admin.desktop

# remove entries from file
#f=file
#t=/tmp/ksm-csv
#s=ksm-csv
#grep -q $s $f
#ret=$?
#if [ "$ret" -eq 0 ]; then
#	cat $f | grep -v $s > $t
#	cp $t $f
#	rm -f $t
#fi
#ret=0

# INIT SCRIPT/SYSTEMD UNIT - uninstall CSV
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/csvd.service ]; then
#		systemctl stop csvd.service
#		systemctl disable csvd.service
#		rm %{_sysddir}/csvd.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	test -x %{_rcdir}/csvd && %{_rcdir}/csvd stop > /dev/null 2>&1
#	insserv -r csvd > /dev/null 2>&1
#	rm -f %{_rcdir}/csvd
#	rm -f %{_sbindir}/rccsvd
#fi

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
#cf=%{_confdir}/csv.conf
#cnfvars='MyVar1 MyVar2'

#c='' s='' t='' cnt=0 i=0 ret=0
#rcfile='' updcmd='' u='' usr=''

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

# enable csv daemon
#test -x %{_bindir}/togglecsv && %{_bindir}/togglecsv -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/csv.directory \
#	/usr/share/applications/csv.desktop \
#	/usr/share/applications/csv-admin.desktop

# add entries to file
#f=file
#te=file.add
#cat %{_datadir}/$te >> $f

# INIT SCRIPT/SYSTEMD UNIT - install CSV
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/csvd.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable csvd.service
#	echo "csvd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start csvd within yast or manual with:"
#	echo "systemctl start csvd.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/csvd.rc %{_rcdir}/csvd
#	ln -sf %{_rcdir}/csvd %{_sbindir}/rccsvd
#	insserv csvd > /dev/null 2>&1
#	echo "csvd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start csvd within yast or manual with rccsvd start"
#fi

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#	echo "Users must create HOME/.csvrc with update-csv"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#
#	echo "If new version then users must update HOME/.csvrc with update-csv"
#fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/csv.conf && cp %{_confdir}/csv.conf %{_confdir}/csv.conf.rpmsave
	#test -e %{_scnfdir}/csv && cp %{_scnfdir}/csv %{_scnfdir}/csv.rpmsave

	# disable csv daemon and stop csvd
	#test -x %{_bindir}/togglecsv && %{_bindir}/togglecsv -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/csvd && %{_rcdir}/csvd stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/csv.directory \
	#	/usr/share/applications/csv.desktop \
	#	/usr/share/applications/csv-admin.desktop

	# remove entries from file
	#f=file
	#t=/tmp/ksm-csv
	#s=ksm-csv
	#grep -q $s $f
	#ret=$?
	#if [ "$ret" -eq 0 ]; then
	#	cat $f | grep -v $s > $t
	#	cp $t $f
	#	rm -f $t
	#fi
	#ret=0

	# INIT SCRIPT/SYSTEMD UNIT - uninstall CSV
	#if [ -d %{_sysddir} ]; then				# systemd
	#	if [ -e %{_sysddir}/csvd.service ]; then
	#		systemctl stop csvd.service
	#		systemctl disable csvd.service
	#		rm %{_sysddir}/csvd.service
	#		systemctl daemon-reload
	#	fi
	#else							# SysV init
	#	test -x %{_rcdir}/csvd && %{_rcdir}/csvd stop > /dev/null 2>&1
	#	insserv -r csvd > /dev/null 2>&1
	#	rm -f %{_rcdir}/csvd
	#	rm -f %{_sbindir}/rccsvd
	#fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-csv
#else							# upgrade package
fi
exit 0

%changelog
* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.1-1.0.0
- Update to the libfuncstd-sh 4.0.0

* Tue May 05 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.1.0
- The package has been revised/improved.

* Mon May 04 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised/improved.

* Mon May 04 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
- The package contains following commands
  all moved from package ksm-utils:
  csv-cat	read and output a csv file
  csv-clean	change a comma separated to a semicolon separated csv
  manage-csv	split and join fields of csv type files
